<template>
  <component
    :is="tag || 'div'"
    :class="{ 'AutoOrList--HasChanged': hasChanged }"
    class="AutoOrList"
  >
    <span v-if="label" class="AutoOrList__Label">{{ label }} </span>

    <Dropdown
      v-model="value"
      :noTranslate="noTranslate"
      :options="options"
      :debounce-delay="0"
      class="AutoOrList__List"
      tag="li"
    />

    <ToggleButton
      v-model="auto"
      :label="labelAuto"
      class="AutoOrList__Auto ToggleButton--reverseOrder"
      tag="li"
    />
    <slot></slot>
  </component>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, reactive, toRefs } from 'vue'
import { Dropdown, Mixins, ToggleButton } from '@/components'
import { SAME_AS_BROWSER } from '@/types/States'

export default defineComponent({
  name: 'AutoOrList',
  components: { Dropdown, ToggleButton },
  emits: [...Mixins.ControlEmits],

  props: {
    tag: String,
    label: String,
    modelValue: null,
    restoreValue: null,
    options: Object as PropType<Record<string, object>>,
    noTranslate: Boolean,
    debounceDelay: Number,
    browser: {
      type: Object as PropType<{ value: unknown; label?: string }>,
      required: true,
    },
  },

  setup(props, context) {
    const p = reactive({ ...toRefs(props) })
    p.debounceDelay = 0
    if (props.modelValue.value === SAME_AS_BROWSER) {
      p.modelValue = p.browser.value
    }
    const isControl = Mixins.isControl<unknown>({
      props: p,
      context,
      processModelValue: (value) =>
        value === SAME_AS_BROWSER ? props.browser.value : value,
    })

    const auto = computed({
      get: () => p.modelValue === SAME_AS_BROWSER,
      set: (value) => {
        if (value) {
          isControl.value.value = SAME_AS_BROWSER
        } else {
          isControl.value.value = props.browser.value
        }
      },
    })

    return {
      auto,
      ...isControl,
      labelAuto: computed(() =>
        [
          isControl.t('settings.sameAsBrowser'),
          '(',
          props.browser.label || props.browser.value,
          ')',
        ].join(' ')
      ),
    }
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;
@use '../../components/controls/mixins/control' as c;

.AutoOrList {
  @include c.control;

  position: relative;
  display: inline-flex;
  flex-wrap: wrap;
  align-items: center;
  padding: v.$spacing;
  border-radius: v.$borderRadius;

  &__Label {
    width: 100%;
    font-weight: bold;
  }

  &__Auto {
    width: auto;
  }
}
</style>
